#include "BQ_Communication.h"
#include "String.h"
#include <stdlib.h>



UART_HandleTypeDef* bq_uart;
DMA_HandleTypeDef* bq_dma;

uint8_t numofcells = DEFAULTNUMOFCELLS;
uint8_t numofdietemps = DEFAULTNUMOFDIETEMPS;

const uint16_t crc16_table[256] = {
        0x0000, 0xC0C1, 0xC181, 0x0140, 0xC301, 0x03C0, 0x0280, 0xC241,
        0xC601, 0x06C0, 0x0780, 0xC741, 0x0500, 0xC5C1, 0xC481, 0x0440,
        0xCC01, 0x0CC0, 0x0D80, 0xCD41, 0x0F00, 0xCFC1, 0xCE81, 0x0E40,
        0x0A00, 0xCAC1, 0xCB81, 0x0B40, 0xC901, 0x09C0, 0x0880, 0xC841,
        0xD801, 0x18C0, 0x1980, 0xD941, 0x1B00, 0xDBC1, 0xDA81, 0x1A40,
        0x1E00, 0xDEC1, 0xDF81, 0x1F40, 0xDD01, 0x1DC0, 0x1C80, 0xDC41,
        0x1400, 0xD4C1, 0xD581, 0x1540, 0xD701, 0x17C0, 0x1680, 0xD641,
        0xD201, 0x12C0, 0x1380, 0xD341, 0x1100, 0xD1C1, 0xD081, 0x1040,
        0xF001, 0x30C0, 0x3180, 0xF141, 0x3300, 0xF3C1, 0xF281, 0x3240,
        0x3600, 0xF6C1, 0xF781, 0x3740, 0xF501, 0x35C0, 0x3480, 0xF441,
        0x3C00, 0xFCC1, 0xFD81, 0x3D40, 0xFF01, 0x3FC0, 0x3E80, 0xFE41,
        0xFA01, 0x3AC0, 0x3B80, 0xFB41, 0x3900, 0xF9C1, 0xF881, 0x3840,
        0x2800, 0xE8C1, 0xE981, 0x2940, 0xEB01, 0x2BC0, 0x2A80, 0xEA41,
        0xEE01, 0x2EC0, 0x2F80, 0xEF41, 0x2D00, 0xEDC1, 0xEC81, 0x2C40,
        0xE401, 0x24C0, 0x2580, 0xE541, 0x2700, 0xE7C1, 0xE681, 0x2640,
        0x2200, 0xE2C1, 0xE381, 0x2340, 0xE101, 0x21C0, 0x2080, 0xE041,
        0xA001, 0x60C0, 0x6180, 0xA141, 0x6300, 0xA3C1, 0xA281, 0x6240,
        0x6600, 0xA6C1, 0xA781, 0x6740, 0xA501, 0x65C0, 0x6480, 0xA441,
        0x6C00, 0xACC1, 0xAD81, 0x6D40, 0xAF01, 0x6FC0, 0x6E80, 0xAE41,
        0xAA01, 0x6AC0, 0x6B80, 0xAB41, 0x6900, 0xA9C1, 0xA881, 0x6840,
        0x7800, 0xB8C1, 0xB981, 0x7940, 0xBB01, 0x7BC0, 0x7A80, 0xBA41,
        0xBE01, 0x7EC0, 0x7F80, 0xBF41, 0x7D00, 0xBDC1, 0xBC81, 0x7C40,
        0xB401, 0x74C0, 0x7580, 0xB541, 0x7700, 0xB7C1, 0xB681, 0x7640,
        0x7200, 0xB2C1, 0xB381, 0x7340, 0xB101, 0x71C0, 0x7080, 0xB041,
        0x5000, 0x90C1, 0x9181, 0x5140, 0x9301, 0x53C0, 0x5280, 0x9241,
        0x9601, 0x56C0, 0x5780, 0x9741, 0x5500, 0x95C1, 0x9481, 0x5440,
        0x9C01, 0x5CC0, 0x5D80, 0x9D41, 0x5F00, 0x9FC1, 0x9E81, 0x5E40,
        0x5A00, 0x9AC1, 0x9B81, 0x5B40, 0x9901, 0x59C0, 0x5880, 0x9841,
        0x8801, 0x48C0, 0x4980, 0x8941, 0x4B00, 0x8BC1, 0x8A81, 0x4A40,
        0x4E00, 0x8EC1, 0x8F81, 0x4F40, 0x8D01, 0x4DC0, 0x4C80, 0x8C41,
        0x4400, 0x84C1, 0x8581, 0x4540, 0x8701, 0x47C0, 0x4680, 0x8641,
        0x8201, 0x42C0, 0x4380, 0x8341, 0x4100, 0x81C1, 0x8081, 0x4040
};


/*	Defines UART and DMA Handle
 *  Always use the Init Routine before using any other function of the Libary
 *
 *
 */
void init_BQCom(UART_HandleTypeDef* uarthandle)
{
	bq_uart = uarthandle;

}


/* Input Message Buffer with the Last two Bytes set to 0. The Last Bytes will be the CRC after use of the Function
 *
 * Returns 0 if the buffer is to small
 *
 * Returns 1 if the Function was successfull
 *
 */
uint16_t Calculate_CRC(uint8_t* message_buffer, uint16_t bufferlength)
{
	uint16_t wCRC = 0;

	if(bufferlength < 3)
	{
		return 0;
	}

	for (uint32_t i = 0; i < (bufferlength-2); i++)
	{
	    wCRC ^= (message_buffer[i]) & 0x00FF;
	    wCRC = crc16_table[wCRC & 0x00FF] ^ (wCRC >> 8);
	}

	message_buffer[bufferlength - 1] = (wCRC>>8) & 0xFF; //Upper CRC Byte is LSB of CRC
	message_buffer[bufferlength - 2] = (wCRC) & 0xFF; //Lower CRC Byte is MSB of CRC

	return 1;
}

/*Checks if the CRC is correct
 *
 * Returns 0 if the Buffer is too small or the CRC is incorrect
 *
 * Returns 1 if the CRC is correct
 */

uint16_t Check_CRC(uint8_t* message_buffer, uint16_t bufferlength)
{
	uint16_t wCRC = 0;

	if(bufferlength < 3)
	{
		return 0;
	}

	for (uint32_t i = 0; i < bufferlength; i++)
	{
	    wCRC ^= (message_buffer[i]) & 0x00FF;
	    wCRC = crc16_table[wCRC & 0x00FF] ^ (wCRC >> 8);
	}

	message_buffer[bufferlength - 1] = (wCRC>>8) & 0xFF; //Upper CRC Byte is LSB of CRC
	message_buffer[bufferlength - 2] = (wCRC) & 0xFF; //Lower CRC Byte is MSB of CRC

	if((message_buffer[bufferlength - 1] == 0) && (message_buffer[bufferlength - 2] == 0))
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

/* Writes data to a register of the BQ76
 *
 * registeraddress specifies the register
 * Makros are available in BQ_Register_Definitions.h
 *
 * registersize defines the register size in bytes
 *
 * data defines the data written to the BQ
 *
 */

uint32_t BQ_Write_Register(uint8_t registeraddress, uint8_t registersize, uint32_t data)
{
	uint8_t* message = (uint8_t*) calloc(registersize+5,sizeof(uint8_t));

	message[0] = FRM_WRT_NR | (registersize & 0x07);
	message[1] = 0x00;
	message[2] = registeraddress;
	for(int i = 0; i < registersize;i++)
	{
		int shift_amount = 8 * (registersize - i - 1);
		message[3+i] = (data>>shift_amount) & 0xFF;
	}

	Calculate_CRC(message, registersize+5);

	BQ_UART_Transmit(message, registersize+5);

	free(message);
	return 1;
}

/*Read the Data of a Register specified by its Address
 *
 * Makros for register names are available in BQ_Register_Definitions.h
 *
 * registersize defines the register size in bytes
 */

uint8_t BQ_Read_Register(uint8_t registeraddress, uint8_t registersize, uint32_t* data)
{
	uint8_t message[6] = {0};
	message[0] = FRM_WRT_R;
	message[1] = 0;
	message[2] = registeraddress;
	message[3] = registersize-1;
	Calculate_CRC(message, 6);

	BQ_UART_Transmit(message, 6);

	uint8_t* recv_message = (uint8_t*) calloc(registersize+3,sizeof(uint8_t));

	BQ_UART_Receive(recv_message, registersize+3);

	uint16_t crccheck = Check_CRC(recv_message, registersize+3);
	if(crccheck == 0)
	{
		free(recv_message);
		return 0;
	}

	data[0] = 0;

	if(registersize > 4)
		registersize = 4;

	for(int n = 0; n < registersize; n++)
	{
		data[0] |= recv_message[1+n]>>(8*n);
	}

	free(recv_message);
	return 1;
}


/*Reads Voltage Measurements from the BQ76
 *
 * Result are Written into the Buffer
 * Buffer size should be 2xMeasured Voltages
 *
 */
uint32_t BQ_ReadMeasurements(uint8_t* buffer, uint8_t bufferlength)
{
	uint8_t message[6] = {};
	message[0] = FRM_WRT_R;
	message[1] = 0x00;
	message[2] = 0x02;
	message[3] = 0x00;
	Calculate_CRC(message, 6);

	BQ_UART_Transmit(message, 6);

	uint16_t recv_len = 2*(numofcells+numofdietemps)+3;
	uint8_t* recv_buf = (uint8_t*) calloc(recv_len,sizeof(uint8_t));
	uint8_t uartstat = BQ_UART_Receive(recv_buf, recv_len);

	if(Check_CRC(recv_buf, recv_len) == 0)
	{
		free(recv_buf);
		return 0;
	}

	if(bufferlength <= 2*(numofcells+numofdietemps))
	{
		memcpy(buffer,&recv_buf[1], bufferlength);
	}

	free(recv_buf);

	return 1;
}

/* Hardware Layer Implementation of the UART Transmit
 *
 */
uint8_t BQ_UART_Transmit(uint8_t* message_buffer, uint16_t bufferlength)
{
	HAL_StatusTypeDef uartstate = HAL_UART_Transmit(bq_uart, message_buffer, bufferlength, BQUARTTIMEOUT);
	return (uint8_t) uartstate;
}

/* Hardware Layer Implementation of the UART Receive
 *
 */
uint8_t BQ_UART_Receive(uint8_t* message_buffer, uint16_t bufferlength)
{
	HAL_StatusTypeDef uartstate = HAL_UART_Receive(bq_uart, message_buffer, bufferlength, BQUARTTIMEOUT);
	return (uint8_t) uartstate;
}

/*Resets the Communication Interface of the BQ76
 *
 *
 */
uint8_t Communication_Reset()
{
	return 0;
}


